
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Codeforces Round #422 (Div. 2) D. My pretty girl Noora / 憋错料</title>

    <meta name="description" content="Codeforces Round #422 (Div. 2) D. My pretty girl Noora 题目链接:Codeforces Round #422 (Div. 2) D. My pretty girl Noora 题意: 给你一个数n和t,l,r,让你求 t0·f(l)?+?t1·f(l?+?1)?+?...?+?tr?-?l·f(r). 其中f(n)是n个人的最少比较次数. 比如n为4,可以先2 2分,然后胜出2个人,最后再比较一次,所以f(4)=3. f(3)=3,因为3为质数,只能这样分. 题解: 这题半天没看清楚题意啊.- -!以为是任意分. 结果是选一个数x,每组都必须为x个人">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Codeforces Round #422 (Div. 2) D. My pretty girl Noora</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>题目链接：<a href="http://codeforces.com/contest/822/problem/D" rel="external nofollow noreferrer">Codeforces Round #422 (Div. 2) D. My pretty girl Noora</a></p>
<p>题意：</p>
<p>给你一个数n和t,l,r，让你求&nbsp;<em>t</em><sup>0</sup>·<em>f</em>(<em>l</em>)?+?<em>t</em><sup>1</sup>·<em>f</em>(<em>l</em>?+?1)?+?...?+?<em>t</em><sup><em>r</em>?-?<em>l</em></sup>·<em>f</em>(<em>r</em>).</p>
<p>其中f(n)是n个人的最少比较次数。</p>
<p>比如n为4,可以先2 2分，然后胜出2个人，最后再比较一次，所以f(4)=3。</p>
<p>f(3)=3,因为3为质数，只能这样分。</p>
<p>题解：</p>
<p>这题半天没看清楚题意啊。- -！以为是任意分。</p>
<p>结果是选一个数x,每组都必须为x个人。</p>
<p>然后正确理解题意后就好做了。</p>
<p>显然将n分的越小答案越优。</p>
<p>所以就有了代码中的dp，具体解释看代码。</p>
<p></p>

<pre> 1 #include&lt;bits/stdc++.h&gt;
 2 #define F(i,a,b) for(int i=(a);i&lt;=(b);++i)
 3 using namespace std;
 4 typedef long long ll;
 5 const int N=5e6+7,P=1e9+7;
 6
 7 ll dp[N],f[N];
 8 int a,l,r;
 9
10 int primes[N+1],tot=0,fac[N];
11 bool vis[N+1];
12 void Euler(){
13     F(i,2,N){
14         if(!vis[i])primes[++tot]=i;
15         F(j,1,tot){
16             if(i*primes[j]&gt;N)break;
17             vis[i*primes[j]]=1;
18             if(i%primes[j]==0)break;
19         }
20     }
21 }
22
23 int main()
24 {
25     Euler();
26     scanf("%d%d%d",&amp;a,&amp;l,&amp;r);
27     dp[2]=1,dp[3]=3,dp[4]=3;
28     F(i,5,r)if(vis[i])
29     {
30         F(j,1,tot)if(i%primes[j]==0)
31         {
32             fac[i]=primes[j];break;//选取最小的因子。
33         }
34     }
35     F(i,5,r)
36     {
37         if(!vis[i])dp[i]=1ll*i*(i-1)/2%P;//i为质数
38         else dp[i]=(i/fac[i]*dp[fac[i]]+dp[i/fac[i]])%P;//i为合数
39     }
40     f[0]=1;
41     F(i,1,r)f[i]=f[i-1]*a%P;
42     ll ans=0;
43     F(i,l,r)ans=(ans+f[i-l]*dp[i])%P;
44     printf("%I64d\n",ans);
45     return 0;
46 }</pre>
<p></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 15:07:31 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/logs/" title="logs">logs</a>, <a href="https://www.biecuoliao.com/tag/can/" title="can">can</a>, <a href="https://www.biecuoliao.com/tag/its/" title="its">its</a>, <a href="https://www.biecuoliao.com/tag/efi/" title="efi">efi</a>, <a href="https://www.biecuoliao.com/tag/const/" title="const">const</a>, <a href="https://www.biecuoliao.com/tag/problem/" title="problem">problem</a>, <a href="https://www.biecuoliao.com/tag/%e6%9c%80%e5%b0%8f/" title="最小">最小</a>, <a href="https://www.biecuoliao.com/tag/break/" title="break">break</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Codeforces Round #422 (Div. 2) D. My pretty girl Noora的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xrjBN4.html" rel="bookmark">Codeforces Round &num;422 &lpar;Div&period; 2&rpar; A&period; I&amp;&num;39&semi;m bored with life 暴力</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				A. I'm bored with life Holidays have finished. Thanks to the help of the hacker Leha, Noora managed to enter the university of her dreams which is located in a town Pavlopolis. It's well known that universities provide students with dormitory for the			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OmOVZM.html" rel="bookmark">Codeforces Round &num;422 &lpar;Div&period; 2&rpar; C&period; Hacker&comma; pack your bags&excl; 排序&plus;贪心</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				链接: http://codeforces.com/contest/822/problem/C 题意: 有x天的假期, 有n张旅行票, 每张票有起始时间l, 结束时间r, 花费cost, 想把假期分成两部分出去旅游, 两部分时间不能重合(ri &lt; lj || rj &lt; li), 问最小花费是多少, 如果不能两部分, 输出-1 题解: CF官方解法, 效率O(nlogn2) 设置一个结构体, struct P{int p, len, cost, type}; 将每张票(l, r, cost) 表			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Z0YKLW4.html" rel="bookmark">Codeforces Round &num;422 &lpar;Div&period; 2&rpar; C Hacker&comma; pack your bags&excl;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				It's well known that the best way to distract from something is to do one's favourite thing. Job is such a thing for Leha. So the hacker began to work hard in order to get rid of boredom. It means that Leha began to hack computers all over the world.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/418qLY3.html" rel="bookmark">Codeforces Round &num;422 &lpar;Div&period; 2&rpar;  A-C</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				A. I'm bored with life 水题 #include &lt;iostream&gt; #include &lt;cstring&gt; #include &lt;cstdio&gt; #include &lt;algorithm&gt; #include &lt;queue&gt; #include &lt;vector&gt; #include &lt;iomanip&gt; #include &lt;math.h&gt; #include &lt;map&gt; using name			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j7JkZ3.html" rel="bookmark">Codeforces Round &num;422 &lpar;Div&period; 2&rpar; E&period; Liar 后缀数组&plus;RMQ&plus;DP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				E. Liar The first semester ended. You know, after the end of the first semester the holidays begin. On holidays Noora decided to return to Vi?kopolis. As a modest souvenir for Leha, she brought a sausage of length m from Pavlopolis. Everyone knows th			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02Dl7n4.html" rel="bookmark">Codeforces Round &num;422 &lpar;Div&period; 2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				A: 给你两个数 (最小的那个&lt;=12)  问这两个数阶乘的GCD 我都吓傻了 直接fac(min(a,b)) 搞定 //By SiriusRen #include &lt;bits/stdc++.h&gt; using namespace std; int A,B; long long t=1; int main(){ scanf(&quot;%d%d&quot;,&amp;A,&amp;B); if(A&gt;B)swap(A,B); for(int i=1;i&lt;=A;i++)t=t*i;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KB6vJM.html" rel="bookmark">Codeforces Round &num;422 &lpar;Div&period; 2&rpar; C&period; Hacker&comma; pack your bags&excl; 排序，贪心</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C. Hacker, pack your bags! It's well known that the best way to distract from something is to do one's favourite thing. Job is such a thing for Leha. So the hacker began to work hard in order to get rid of boredom. It means that Leha began to hack co			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/388DOn3.html" rel="bookmark">Codeforces Round &num;279 &lpar;Div&period; 2&rpar; ABCD</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Codeforces Round #279 (Div. 2) 做得我都变绿了! Problems # Name     A Team Olympiad standard input/output 1 s, 256 MB  x2377 B Queue standard input/output 2 s, 256 MB  x1250 C Hacking Cypher standard input/output 1 s, 256 MB  x740 D Chocolate standard input/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/XMgyXL3.html" rel="bookmark">Codeforces Round &num;428 &lpar;Div&period; 2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include&lt;bits/stdc++.h&gt; using namespace std; #pragma comment(linker, &quot;/STACK:102400000,102400000&quot;) #define rep(i,a,b) for (int i=a; i&lt;=b; ++i) #define per(i,b,a) for (int i=b; i&gt;=a; --i			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r5PWb0.html" rel="bookmark" class="title">常用cmd命令大全</a>
					<div>
						最早的电脑系统是从DOS系统开始,DOS时代没有现在Windows这样的视窗操作界面,让你输入命令.随着电脑的发展至今,学习一些常用cmd命令大全是很有必要.大多数的程序员高手们或计算机专家在DOS系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWyN7b3.html" rel="bookmark" class="title">ASP&period;NET Razor 视图引擎编程参考</a>
					<div>
						ASP.NET Razor 视图引擎编程参考 转载请注明出处:http://surfsky.cnblogs.com Rasor 视图引擎    http://msdn.microsoft.com/zh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QWRjl0.html" rel="bookmark" class="title">一些WPF中的滤镜特效&mdash;&mdash;Effect Library</a>
					<div>
						WPF支持类似PhotoShop的滤镜功能,称之为Effect.在.Net 4.0中,WPF就废弃了对BitMapEffect的支持,转向使用支持GPU加速的Effect类,例如,我们可以使用如下代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NJY224.html" rel="bookmark" class="title">jquery validate用法总结</a>
					<div>
						jquery validate是本人用过的最好用的验证组件,但其文档写的真是不敢恭维,现将一些常见用法总结如下(持续更新). 1. js触发表单验证 //触发整个表单的验证 $('form').val ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6NxdGM.html" rel="bookmark" class="title">虚拟机virtualBox设置共享文件后，linux配置</a>
					<div>
						1.在/mnt下创建共享目录 mkdir /mnt/share 2.关联外部目录 mount -t vboxsf 共享文件夹名 /mnt/share/ 如:mount -t vboxsf BaiduS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/388mV23.html" rel="bookmark" class="title">第一章：spring mvc 的hello world -&amp;lt&semi;蒋永录帮帮你&amp;gt&semi;</a>
					<div>
						一:web.xml配置 &lt;!-- Spring MVC配置 --&gt; &lt;servlet&gt; &lt;servlet-name&gt;Spring MVC Dispatcher Se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGPDlo0.html" rel="bookmark" class="title">《格蠹汇编》调试笔记</a>
					<div>
						以前也就是把Windbg作为一个调试所写驱动的调试器.只进行源码级的调试,运用的比较浅显. 最近研读张银奎老师的&lt;软件调试&gt;获益良多,刚好与之配套的&lt;格蠹汇编&gt;提供了老师大量的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dAV893.html" rel="bookmark" class="title">C语言知识总结</a>
					<div>
						明白一些变量 熟悉一些语句 组合一些函数 C语言——&gt;库  帮你写好放在库中 魔数 凭空变出来的数字,不知道 数字表示的含义,影响代码的可读性. C语音的参数传递 非常特殊,传递的是一个替身.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5YRL3.html" rel="bookmark" class="title">Yii操作session方法总结</a>
					<div>
						设置session变量: Yii::app()-&gt;session['var']='value'; 使用session: echo Yii::app()-&gt;session['var']; 移 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXnnKG3.html" rel="bookmark" class="title">技术文章</a>
					<div>
						主流全文索引工具的比较( Lucene, Sphinx, solr, elastic search) 用Kibana和logstash快速搭建实时日志查询.收集与分析系统 logrotate 进行ng ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZDE13.html" rel="bookmark" class="title">G - Antiarithmetic&quest;</a>
					<div>
						uva 10730 题意:给出一列数字,如果其中存在长度大于等于3的等差数列,输出no,不存在就输出yes 这道题标定了数列长度n,而且这n个数数据范围是从0到n-1,没有相同的数,这就给我们枚举提供 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wjNKV0.html" rel="bookmark" class="title">delphi 判断给定日期的天数，给定日期距离月初的天数，给定日期距离月末的天数</a>
					<div>
						uses dateutils; //判断给定日期的天数 label1.caption := inttostr(DaysInAMonth(yearof(StrToDate(Trim(Edit_riqi. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lkQPXM.html" rel="bookmark" class="title">IO流 流操作规律 转换流的由来</a>
					<div>
						package com.yyq; import java.io.*; /* * 转换流--------指定码表 * 需求: 想将一个文件的数据打印在控制台上 * 源:文件 * 目的:控制台 * 流操作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KvRerM.html" rel="bookmark" class="title">利用ViewPager实现3D画廊效果及其图片加载优化</a>
					<div>
						前言 对于ViewPager,相信大家都已经很熟悉了,在各种切换场景比如Fragment切换.选项卡的切换或者顶部轮播图片等都可以用ViewPager去实现.那么本篇文章带来ViewPager的一种实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AWwnv0.html" rel="bookmark" class="title">zookeeper 实现屏障&lowbar;Barrier</a>
					<div>
						根据官网的demo,自己的理解,加了相应的注释,这里把代码贴出来,如下, Barrier package com.usfot; import org.apache.zookeeper.CreateMo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KjPZYM.html" rel="bookmark" class="title">微信网页版登陆实现</a>
					<div>
						1. 每打开一次微信网页版页面的时候会随机生成一个含有唯一 uid 的二维码,每次刷新页面都会不一样(这个可以保证一个 uid 只可以绑定一个账号和密码,如果一个 uid 可以绑定多个账号和密码,那么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41GvQo0.html" rel="bookmark" class="title">PMP 项目成本管理</a>
					<div>
						1.规划成本管理 输入 1. 项目管理计划 2. 项目章程 3. 事业环境因素 4. 组织过程资产 工具与技术 1. 专家判断 2. 分析技术 3. 会议 输出 1.成本管理计划 2.估算成本 输入  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KPeDK3.html" rel="bookmark" class="title">关于等价标准形的专题讨论</a>
					<div>
						$\bf命题:$任意方阵$A$均可分解为可逆阵$B$与幂等阵$C$之积 1 $\bf命题:$任意方阵$A$均可分解为可逆阵$B$与对称阵$C$之积 1 $\bf命题:$设$A,B \in {P^{n  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NQ2OV3.html" rel="bookmark" class="title">WampServer知识点</a>
					<div>
						1.修改默认端口 1)打开文件:C:\wamp\bin\apache\apache2.4.9\conf\httpd.conf 2)修改默认端口,并重新重启服务. #Listen 12.34.56.78 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm7PkX3.html" rel="bookmark" class="title">HDOJ-最大子矩阵&lpar;二维dp&rpar;</a>
					<div>
						动态规划还需加强练习!!!!!第一次写的果断超时 最大子矩阵 Time Limit: 30000/10000 MS (Java/Others)    Memory Limit: 32768/32768 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
